//+===================+
//| Block Board Chase |
//|      By: ZSNO     |
//|  Idea from Kirby  |
//|  64, Multiplayer  |
//+===================+
$BBC::Normal=getClosestPaintColor("0.5 0.5 0.5");
$BBC::Dark=getClosestPaintColor("0.25 0.25 0.25");
if($BBC::Normal == $BBC::Dark)
{
	$BBC::Dark = getclosestpaintcolor("0 0 0");
}
//Now works with all colorsets :D
%error = forceRequiredAddOn("Gamemode_TeamDeathmatch");
if(%error == $Error::AddOn_NotFound)
{
	error("Gamemode_BBC - required Add-On Gamemode_TeamDeathmatch not found");
	return;
}
datablock ProjectileData(BBCPickProjectile)
{
   directDamage        = 0;
   radiusDamage        = 0;
   damageRadius        = 0;
   explosion           = hammerExplosion;
   muzzleVelocity      = 50;
   velInheritFactor    = 1;
   armingDelay         = 0;
   lifetime            = 150;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;
   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};

datablock ItemData(BBCPickItem)
{
	category = "Weapon";
	className = "Weapon";
	shapeFile = "base/data/shapes/hammer.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	uiName = "Block Board Chase Pick ";
	iconName = "base/client/ui/ItemIcons/hammer";
	doColorShift = true;
	colorShiftColor = "0.5 0.5 0.5 1";
	image = BBCPickImage;
};
datablock ShapeBaseImageData(BBCPickImage)
{
   shapeFile = "base/data/shapes/hammer.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0"; 
   correctMuzzleVector = false;
   eyeOffset = "0.7 1.2 -0.25";
   className = "WeaponImage";
   item = BBCPickItem;
   ammo = " ";
   projectile = BBCPickProjectile;
   projectileType = Projectile;
   melee = true;
   doRetraction = false;
   armReady = true;
   doColorShift = true;
   colorShiftColor = "0.5 0.5 0.5 1";
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 1;
	stateTransitionOnTimeout[0]       = "Ready";

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "StopFire";
	stateTimeoutValue[3]            = 0.2;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;

	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 3;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	stateSequence[5]                = "StopFire";
	stateScript[5]                 = "onStopFire";
};
function BBCPickImage::onFire(%this, %obj, %slot)
{
	parent::onFire(%this,%obj,%slot);
	%obj.playthread(2, armattack);
}
function BBCPickImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
}
datablock PlayerData(PlayerBBC : PlayerStandardArmor)
{
	jumpforce=0;
	canjet = 0;
	uiname = "BBC Playertype ";
};
function BBCPickProjectile::oncollision(%this,%obj,%col,%fade,%pos,%normal)
{
	if(%col.getclassname()$="fxDTSBrick")
	{
		if(%col.Datablock $="brick4xCubeData")
		{
			%bc=getClosestPaintColor(%obj.client.chestColor);
			%pp=%obj.client.player.getforwardvector();
			if(mABS(getword(%pp,0)) > mABS(getword(%pp,1)))
			{
				if(stricmp(getword(%pp,0),mABS(getword(%pp,0))) == 0)
					%col.BBCrelay(%bc,1);
				else
					%col.BBCrelay(%bc,2);
			}
			else
			{
				if(stricmp(getword(%pp,1),mABS(getword(%pp,1))) == 0)
					%col.BBCrelay(%bc,3);
				else
					%col.BBCrelay(%bc,4);
			}
		}
	}
}
//+=============+
//| 1 0   East  |
//| -1 0  West  |
//| 0 1   North |
//| 0 -1  South |
//+=============+
function fxDTSBrick::BBCrelay(%this,%bc,%num)
{
	switch$ (%num)
	{
		case "1":
			%this.setcolor(%bc);
			%this.schedule(500,fakeKillbrick,"0 0 0",3);
			%this.schedule(2000,setcolor,$BBC::Normal);
			%position = getword(%this.getPosition(),0) + 2 SPC getwords(%this.getposition(),1,2);
			%boxSize = "0.25 0.25 0.25";
			%mask = ($TypeMasks::FxBrickObjectType);
			initContainerBoxSearch(%position,%boxSize,%mask);
			while(%brick = containerSearchNext())
			{
				if(%brick == %this)
					return;
				else
					%brick.BBCrelay(%bc,1);
			}
		case "2":
			%this.setcolor(%bc);
			%this.schedule(500,fakeKillbrick,"0 0 0",3);
			%this.schedule(2000,setcolor,$BBC::Normal);
			%position = getword(%this.getPosition(),0) - 2 SPC getwords(%this.getposition(),1,2);
			%boxSize = "0.25 0.25 0.25";
			%mask = ($TypeMasks::FxBrickObjectType);
			initContainerBoxSearch(%position,%boxSize,%mask);
			while(%brick = containerSearchNext())
			{
				if(%brick == %this)
					return;
				else
					%brick.BBCrelay(%bc,2);
			}
		case "3":
			%this.setcolor(%bc);
			%this.schedule(500,fakeKillbrick,"0 0 0",3);
			%this.schedule(2000,setcolor,$BBC::Normal);
			%position = getword(%this.getPosition(),0) SPC getword(%this.getPosition(),1) + 2 SPC getword(%this.getposition(),2);
			%boxSize = "0.25 0.25 0.25";
			%mask = ($TypeMasks::FxBrickObjectType);
			initContainerBoxSearch(%position,%boxSize,%mask);
			while(%brick = containerSearchNext())
			{
				if(%brick == %this)
					return;
				else
					%brick.BBCrelay(%bc,3);
			}
		case "4":
			%this.setcolor(%bc);
			%this.schedule(500,fakeKillbrick,"0 0 0",3);
			%this.schedule(2000,setcolor,$BBC::Normal);
			%position = getword(%this.getPosition(),0) SPC getword(%this.getPosition(),1) - 2 SPC getword(%this.getposition(),2);
			%boxSize = "0.25 0.25 0.25";
			%mask = ($TypeMasks::FxBrickObjectType);
			initContainerBoxSearch(%position,%boxSize,%mask);
			while(%brick = containerSearchNext())
			{
				if(%brick == %this)
					return;
				else
					%brick.BBCrelay(%bc,4);
			}
	}
}

//function findplayerdirection(%player)
//{
//	%fv=%player.getForwardVector();
//	if(mABS(getword(%fv,0)) > mABS(getword(%fv,1)))
//	{
//		if(stricmp(getword(%fv,0),mABS(getword(%fv,0))) == 0)
//			return 2;
//		else
//			return 4;
//	}
//	else
//	{
//		if(stricmp(getword(%fv,1),mABS(getword(%fv,1))) == 0)
//			return 1;
//		else
//			return 3;
//	}
//Returning values mean
//1 - North
//2 - East
//3 - South
//4 - West
//}

registerGameMode("Block Board Chase","BBC",0,0,0);
setGameModeHelp("Block Board Chase","Add-Ons/Gamemode_BBC/rules_bbc.txt");
addGameModeRule("Block Board Chase","Lives","int 0 10",0);
addGameModeRule("Block Board Chase","Ring 1 Fall-off","int 0 60",0);
addGameModeRule("Block Board Chase","Ring 2 Fall-off","int 0 120",0);
addGameModeRule("Block Board Chase","Ring 3 Fall-off","int 0 180",0);
function GameMode_BBC_onModeUpdateRule0(%mini,%rulevalue,%oldvalue,%modestart)
{
	return !(%modestart && %rulevalue == 0);
}
function GameMode_BBC_onMiniReset(%mini,%client)
{
	if(%mini.tdmModeRule[0] != 0)
		%mini.messageAll('',"\c5You have \c3" @ %mini.tdmModeRule[0] @ "\c5 " @ (%mini.tdmModeRule[0] == 1 ? "life" : "lives") @ " remaining.");
	%mini.setLivesLimit(%mini.tdmModeRule[0]);
	Gamemode_BBC_onModeEnd(%mini,%client);
	Gamemode_BBC_onModeStart(%mini,%client);
}
function GameMode_BBC_onModeStart(%mini,%client)
{
	$BBCRing1=schedule(%mini.tdmModeRule1*1000,0,BBCringfalloff,%client,1);
	$BBCRing2=schedule(%mini.tdmModeRule2*1000,0,BBCringfalloff,%client,2);
	$BBCRing3=schedule(%mini.tdmModeRule3*1000,0,BBCringfalloff,%client,3);
}
function GameMode_BBC_onModeEnd(%mini,%client)
{
	cancel($BBCRing1);
	cancel($BBCRing2);
	cancel($BBCRing3);
	%client=%mini.owner;
	%brick=%client.brickgroup;
	if(isObject(%client.brickgroup.NTObject_BBC_Ring1_0))
	{
		for(%i=0;%i<%brick.NTObjectCount_BBC_Ring1;%i++)
		{
			%brick.NTObject_BBC_Ring1_[%i].respawn();
			%brick.NTObject_BBC_Ring1_[%i].setcolor($BBC::Normal);
			%brick.NTObject_BBC_Ring1_[%i].setraycasting(1);
		}
	}
	if(isObject(%client.brickgroup.NTObject_BBC_Ring2_0))
	{
		for(%i=0;%i<%brick.NTObjectCount_BBC_Ring2;%i++)
		{
			%brick.NTObject_BBC_Ring2_[%i].respawn();
			%brick.NTObject_BBC_Ring2_[%i].setcolor($BBC::Normal);
			%brick.NTObject_BBC_Ring2_[%i].setraycasting(1);
		}
	}
	if(isObject(%client.brickgroup.NTObject_BBC_Ring3_0))
	{
		for(%i=0;%i<%brick.NTObjectCount_BBC_Ring3;%i++)
		{
			%brick.NTObject_BBC_Ring3_[%i].respawn();
			%brick.NTObject_BBC_Ring3_[%i].setcolor($BBC::Normal);
			%brick.NTObject_BBC_Ring3_[%i].setraycasting(1);
		}
	}
}
function BBCringfalloff(%client,%num)
{
	switch$ (%num)
	{
		case "1":
			%brick=%client.brickgroup;
			if(isObject(%client.brickgroup.NTObject_BBC_Ring1_0))
			{
				for(%i=0;%i<%brick.NTObjectCount_BBC_Ring1;%i++)
				{
					%brick.NTObject_BBC_Ring1_[%i].setcolor($BBC::Dark);
					%brick.NTObject_BBC_Ring1_[%i].setraycasting(0);
					%brick.NTObject_BBC_Ring1_[%i].schedule(1000,fakekillbrick,"0 0 0",-1);
				}
			}
		case "2":
			%brick=%client.brickgroup;
			if(isObject(%client.brickgroup.NTObject_BBC_Ring2_0))
			{
				for(%i=0;%i<%brick.NTObjectCount_BBC_Ring2;%i++)
				{
					%brick.NTObject_BBC_Ring2_[%i].setcolor($BBC::Dark);
					%brick.NTObject_BBC_Ring2_[%i].setraycasting(0);
					%brick.NTObject_BBC_Ring2_[%i].schedule(1000,fakekillbrick,"0 0 0",-1);
				}
			}
		case "3":
			%brick=%client.brickgroup;
			if(isObject(%client.brickgroup.NTObject_BBC_Ring3_0))
			{
				for(%i=0;%i<%brick.NTObjectCount_BBC_Ring3;%i++)
				{
					%brick.NTObject_BBC_Ring3_[%i].setcolor($BBC::Dark);
					%brick.NTObject_BBC_Ring3_[%i].setraycasting(0);
					%brick.NTObject_BBC_Ring3_[%i].schedule(1000,fakekillbrick,"0 0 0",-1);
				}
			}
	}
}